package com.game.xiyou.bean;

package ..deTemp.1731769068451;

import com.game.xiyou.SanGuoUtil;
import com.game.xiyou.bean.GameChiBiRnd;
import com.game.xiyou.bean.GameChiBiRole;
import com.game.xiyou.bean.UserRole;
import com.game.xiyou.db.GameChiBiDAO;
import com.game.xiyou.db.GameDAO;
import com.game.xiyou.db.GoodsDAO;
import com.game.xiyou.db.RoleDAO;
import com.game.xiyou.logic.ChatLogic;
import com.game.xiyou.logic.User;
import com.game.xiyou.manager.Session;
import com.mag8.cache.engine.FluctuantCache;
import com.sjgo5.forum.Util;
import java.util.ArrayList;
import java.util.Hashtable;
import java.util.Random;

public class GameChiBi {
  private static int lvl1 = 300;
  
  private static int lvl2 = 640;
  
  private static int curRndNum;
  
  private static long curRndStartTime;
  
  private static long curRndEndTime;
  
  private static boolean isInit = false;
  
  private static String[] aReport = new String[] { 
      "a趁夜劫粮,b士气大减", 
      "a大受鼓舞,强攻b大营", 
      "a使用火计,b中计损兵", 
      "a武将单挑,取b武将首级", 
      "a山路埋伏,b中伏惨败", 
      "a全军冲锋,b战线后退", 
      "a增兵前线,b士气低落", 
      "a假传军令,b中计内斗", 
      "a援军到达,b受夹击大败", 
      "a迂回攻击,b侧翼受损", 
      "a新得名将,b士气低落", 
      "a得奇才军师,b人心浮动", 
      "a奉旨讨逆,b人心不稳", 
      "a偷袭b后方,b士气大落", 
      "a深夜偷营,b损失严重", 
      "a长驱直入,b主将受伤", 
      "a使用诈降计,b中计受损", 
      "a调动船队突击,b水军大败", 
      "a猛将直取b主将,士气大振", 
      "a阵法精奇,b无以应对", 
      "a无懈可击,b无可奈何", 
      "a指挥若定,b无功而返", 
      "a三军齐动,b望风而逃", 
      "a诱敌深入,b中伏大败", 
      "a火箭齐射,火烧b大营" };
  
  private static Hashtable<Integer, Integer> resultlist = new Hashtable<>();
  
  public static int getLvl1() {
    return lvl1;
  }
  
  public static int getLvl2() {
    return lvl2;
  }
  
  public static void setProb1(int prob1) {
    lvl1 = prob1;
  }
  
  public static void setProb2(int prob2) {
    lvl2 = prob2;
  }
  
  public static void init() {
    if (isInit)
      return; 
    GameChiBiRnd rnd = getLastRnd();
    if (rnd != null) {
      if (rnd.getResult() == 0) {
        curRndNum = rnd.getRndNum();
        curRndStartTime = System.currentTimeMillis();
        curRndEndTime = curRndStartTime + 600000L;
      } else {
        curRndNum = rnd.getRndNum() + 1;
        curRndStartTime = System.currentTimeMillis();
        curRndEndTime = curRndStartTime + 600000L;
        insertRnd(curRndNum, getWinSide());
      } 
      isInit = true;
    } 
  }
  
  public static void run() {
    init();
    if (!isInit)
      return; 
    if (!SanGuoUtil.has_chibidou)
      return; 
    if (!isEnd())
      return; 
    curRndNum++;
    curRndStartTime = System.currentTimeMillis();
    curRndEndTime = curRndStartTime + 600000L;
    insertRnd(curRndNum, getWinSide());
    int iSide = getWinSide_two(curRndNum - 1);
    if (iSide == 0) {
      System.out.println("DEBUG:GameChiBi.run:getWinSide failed.");
      return;
    } 
    int bonusSilver = 0;
    int bonusGold = 0;
    int silverSum = 0;
    int goldSum = 0;
    String strSide = null;
    strSide = getSideStr(iSide);
    ArrayList<GameChiBiRole> list = GameChiBiDAO.getUserByRndNum(curRndNum - 1);
    if (list == null) {
      System.out.println("DEBUG:GameChibi.run:GameChiBiDAO.getRndWinner failed. curRndNum = " + 
          curRndNum);
      return;
    } 
    for (GameChiBiRole curRole : list) {
      if (curRole.getSide() == iSide) {
        bonusSilver = (int)(curRole.getSilver() * 2.7D);
        bonusGold = (int)(curRole.getGold() * 2.7D);
        if (bonusSilver != 0) {
          ChatLogic.addSystemMessage(curRole.getRoleId(), "恭喜您支援的" + strSide + "获得胜利,您获得战利品" + bonusSilver + "银两,请前往娱乐场领取.");
          GameDAO.insert_daxiao_record(curRole.getRoleId(), bonusSilver, 1);
        } 
        silverSum += bonusSilver;
        if (bonusGold != 0) {
          ChatLogic.addSystemMessage(curRole.getRoleId(), "恭喜您支援的" + strSide + "获得胜利,您获得战利品" + bonusGold + "金砖,请前往娱乐场领取.");
          GameDAO.insert_daxiao_record(curRole.getRoleId(), bonusGold, 1);
        } 
        goldSum += bonusGold;
        GameChiBiDAO.updateWagerResult(curRole.getWagerId(), bonusGold, bonusSilver);
        continue;
      } 
      ChatLogic.addSystemMessage(curRole.getRoleId(), "很遗憾您支援的军队本次战斗战败.");
    } 
    if (silverSum > 50000 || goldSum >= 2900)
      ChatLogic.sendWordChat("三界斗胜负已分,获胜方给支持者发放战利品" + goldSum + "金砖，" + silverSum + "银两"); 
    GameChiBiDAO.updateRnd(iSide, goldSum, silverSum, curRndNum - 1);
    FluctuantCache.getInstance()
      .terminateCacheObject("getGameChiBiRndList");
    FluctuantCache.getInstance().terminateCacheObject(
        "getGameChiBiUserRankingList");
  }
  
  public static String getReport(int iSide) {
    int iRandom = 0;
    int iSide1 = 0;
    int iSide2 = 0;
    String strRtn = null;
    String strSide1 = null;
    String strSide2 = null;
    Random rand = new Random();
    if (iSide != 0) {
      strRtn = getSideStr(iSide);
      strRtn = String.valueOf(strRtn) + "获得您的增援,军威大振";
      return strRtn;
    } 
    iSide1 = rand.nextInt(3) + 1;
    if (3 == iSide1) {
      iSide2 = iSide1 - 1;
    } else {
      iSide2 = iSide1 + 1;
    } 
    strSide1 = getSideStr(iSide1);
    strSide2 = getSideStr(iSide2);
    iRandom = rand.nextInt(20);
    strRtn = aReport[iRandom];
    strRtn = strRtn.replaceAll("a", strSide1);
    strRtn = strRtn.replaceAll("b", strSide2);
    return strRtn;
  }
  
  public static boolean isEnd() {
    if (System.currentTimeMillis() < curRndEndTime || 
      0L == curRndEndTime)
      return false; 
    return true;
  }
  
  public static int getWinSide() {
    Random rand = new Random();
    int side = rand.nextInt(3) + 1;
    int winSide = getResult(side);
    return winSide;
  }
  
  public static int getWinSide_two(int num) {
    int winSide = GameChiBiDAO.getResult2(num);
    return winSide;
  }
  
  public static int getRndNum(int num) {
    Random rnd = new Random();
    ArrayList<Integer> list = new ArrayList();
    for (int i = 1; i < 4; i++) {
      if (i != num)
        list.add(Integer.valueOf(i)); 
    } 
    return ((Integer)list.get(rnd.nextInt(2))).intValue();
  }
  
  public static int getResult(int num) {
    int result = num;
    Integer count = resultlist.get(Integer.valueOf(num));
    if (count == null || count.intValue() == 0) {
      resultlist.clear();
      resultlist.put(Integer.valueOf(num), Integer.valueOf(1));
    } else if (count.intValue() >= 7) {
      result = getRndNum(num);
      resultlist.clear();
      resultlist.put(Integer.valueOf(result), Integer.valueOf(1));
    } else {
      resultlist.put(Integer.valueOf(num), Integer.valueOf(count.intValue() + 1));
    } 
    return result;
  }
  
  public static void insertRnd(int iRndNum, int num) {
    GameChiBiDAO.insertRnd(iRndNum, num);
  }
  
  public static String reinforce(Session ses, int iSide, int iNum, int type) {
    if (ses == null || SanGuoUtil.SYS_IS_BUSY)
      return "系统繁忙,请稍后再试."; 
    if (User.isFight(ses.getSid()))
      return "您有一场战斗正在进行中,不能使用娱乐场功能."; 
    String strRtn = null;
    if (!isInit || curRndNum == 0) {
      strRtn = "对不起,系统繁忙,请稍候再重操作增援";
      return strRtn;
    } 
    if (ses.getRoleid() == 0 || iSide < 1 || iSide > 3) {
      strRtn = "您的输入有误,请重新输入";
      return strRtn;
    } 
    GameChiBiRole role = null;
    if (type == 1) {
      if (iNum < 100) {
        strRtn = "增援物资不能少于100金砖";
        return strRtn;
      } 
      if (iNum > 3000) {
        strRtn = "增援物资不能大于3000金砖";
        return strRtn;
      } 
      int last = getUserWagerRcdSideByRND(ses.getRoleid(), curRndNum);
      int num = 0;
      for (int i = 1; i <= 3; i++) {
        role = GameChiBiDAO.getUserWagerRcdBySide(ses.getRoleid(), curRndNum, i);
        if (role != null)
          num++; 
      } 
      UserRole ur = User.getUserRole(ses.getSid());
      if (ur == null)
        return "系统繁忙,请稍后再试"; 
      int avilableSilver = ur.getGold();
      if (avilableSilver < 0)
        avilableSilver = 0; 
      if (avilableSilver < iNum)
        return "您的金砖不够增援"; 
      role = GameChiBiDAO.getUserWagerRcdBySide(ses.getRoleid(), curRndNum, iSide);
      if (role == null) {
        if (num >= 2) {
          strRtn = "每次只能增援2个势力.";
          return strRtn;
        } 
        if (RoleDAO.updateRoleAtt(ses.getRoleid(), -iNum, "update xiyou_user_role set gold = gold + ? where id = ?")) {
          ur = User.reloadUserRole(ses.getRoleid());
          FluctuantCache.getInstance().terminateCacheObject("SGgetUserRoleBuf|" + ses.getRoleid());
          GameChiBiDAO.insertWagerRcd(ses.getRoleid(), curRndNum, iSide, iNum, 0);
          GoodsDAO.saveLog_Gold(ses.getRoleid(), -iNum, 3, 0, 0, ur.getGold());
          clearUserWagerRcdSideByRND(ses.getRoleid(), curRndNum);
        } 
      } else {
        if (role.getGold() + iNum > 3000) {
          strRtn = "增援的金砖不能超过3000";
          return strRtn;
        } 
        if (RoleDAO.updateRoleAtt(ses.getRoleid(), -iNum, "update xiyou_user_role set gold = gold + ? where id = ?")) {
          ur = User.reloadUserRole(ses.getRoleid());
          FluctuantCache.getInstance().terminateCacheObject("SGgetUserRoleBuf|" + ses.getRoleid());
          GameChiBiDAO.updateUserWagerRcdBySide(role.getWagerId(), iNum, 0);
          GoodsDAO.saveLog_Gold(ses.getRoleid(), -iNum, 3, 0, 0, ur.getGold());
        } 
      } 
    } else if (type == 2) {
      if (iNum < 1000) {
        strRtn = "增援物资不能少于1000银两";
        return strRtn;
      } 
      if (iNum > 100000) {
        strRtn = "增援物资不能大于100000银两";
        return strRtn;
      } 
      int last = getUserWagerRcdSideByRND(ses.getRoleid(), curRndNum);
      int num = 0;
      for (int i = 1; i <= 3; i++) {
        role = GameChiBiDAO.getUserWagerRcdBySide(ses.getRoleid(), curRndNum, i);
        if (role != null)
          num++; 
      } 
      UserRole ur = User.getUserRole(ses.getSid());
      if (ur == null)
        return "系统繁忙,请稍后再试"; 
      int avilableSilver = ur.getSilver();
      if (avilableSilver < 0)
        avilableSilver = 0; 
      if (avilableSilver < iNum)
        return "您的银两不够增援"; 
      role = GameChiBiDAO.getUserWagerRcdBySide(ses.getRoleid(), curRndNum, iSide);
      if (role == null) {
        if (num >= 2) {
          strRtn = "每次只能增援2个势力.";
          return strRtn;
        } 
        if (RoleDAO.updateRoleAtt(ses.getRoleid(), -iNum, "update xiyou_user_role set silver = silver + ? where id = ?")) {
          ur = User.reloadUserRole(ses.getRoleid());
          FluctuantCache.getInstance().terminateCacheObject("SGgetUserRoleBuf|" + ses.getRoleid());
          GameChiBiDAO.insertWagerRcd(ses.getRoleid(), curRndNum, iSide, 0, iNum);
          GoodsDAO.saveLog_Money(ses.getRoleid(), -iNum, 3, 0, 0, ur.getSilver());
          clearUserWagerRcdSideByRND(ses.getRoleid(), curRndNum);
        } 
      } else {
        if (role.getSilver() + iNum > 100000) {
          strRtn = "增援的银两不能超过100000";
          return strRtn;
        } 
        if (RoleDAO.updateRoleAtt(ses.getRoleid(), -iNum, "update xiyou_user_role set silver = silver + ? where id = ?")) {
          ur = User.reloadUserRole(ses.getRoleid());
          FluctuantCache.getInstance().terminateCacheObject("SGgetUserRoleBuf|" + ses.getRoleid());
          GameChiBiDAO.updateUserWagerRcdBySide(role.getWagerId(), 0, iNum);
          GoodsDAO.saveLog_Money(ses.getRoleid(), -iNum, 3, 0, 0, ur.getSilver());
        } 
      } 
    } 
    return strRtn;
  }
  
  public static int getCurRndNum() {
    return curRndNum;
  }
  
  public static int getEndLeavingMin() {
    long lTmp = curRndEndTime - System.currentTimeMillis();
    if (lTmp < 60000L)
      return 1; 
    return (int)lTmp / 60000;
  }
  
  public static String getEndLeavingTime() {
    if (curRndEndTime - System.currentTimeMillis() < 10000L)
      return null; 
    String str = SanGuoUtil.getLeavingTime(Util.formatTime(curRndEndTime, "yyyy-MM-dd HH:mm:ss"));
    return str;
  }
  
  public static String getSideStr(int iSide) {
    String rtnStr = null;
    switch (iSide) {
      case 1:
        rtnStr = "魔界";
        return rtnStr;
      case 2:
        rtnStr = "佛界";
        return rtnStr;
      case 3:
        rtnStr = "神界";
        return rtnStr;
    } 
    rtnStr = null;
    return rtnStr;
  }
  
  public static ArrayList<GameChiBiRole> getSideSupply(int rndNum) {
    return GameChiBiDAO.getSideSupply(rndNum);
  }
  
  public static GameChiBiRnd getLastRnd() {
    return GameChiBiDAO.getLastRnd();
  }
  
  public static int getRndResult(int rndNum) {
    return GameChiBiDAO.getRndResult(rndNum);
  }
  
  public static ArrayList<GameChiBiRnd> getRndList() {
    ArrayList<GameChiBiRnd> list = null;
    String key = "getGameChiBiRndList";
    if ((list = (ArrayList)FluctuantCache.getInstance().getCacheObject(key)) == null) {
      list = GameChiBiDAO.getRndList();
      if (list == null || list.size() == 0)
        return null; 
      FluctuantCache.getInstance().putCacheObject(key, list);
    } 
    return list;
  }
  
  public static ArrayList<GameChiBiRole> getUserWagerRcd(int roleId, int pageid) {
    return GameChiBiDAO.getUserWagerRcd(roleId, pageid);
  }
  
  public static ArrayList<GameChiBiRole> getUserRndWager(int roleId, int rndNum) {
    return GameChiBiDAO.getUserRndWager(roleId, rndNum);
  }
  
  public static ArrayList<GameChiBiRole> getUserRankingList() {
    ArrayList<GameChiBiRole> list = null;
    String key = "getGameChiBiUserRankingList";
    list = (ArrayList)FluctuantCache.getInstance().getCacheObject(key);
    if (list == null || list.size() == 0) {
      list = GameChiBiDAO.getUserRankingList();
      if (list == null || list.size() == 0)
        return null; 
      FluctuantCache.getInstance().putCacheObject(key, list);
    } 
    return list;
  }
  
  public static ArrayList<GameChiBiRole> getUserRndRankingList(int rndNum) {
    return GameChiBiDAO.getUserRndRankingList(rndNum);
  }
  
  public static void clearUserWagerRcdSideByRND(int role_id, int rnd_num) {
    String key = "getUserWagerRcdSideByRND" + role_id + "|" + rnd_num;
    FluctuantCache.getInstance().terminateCacheObject(key);
  }
  
  public static int getUserWagerRcdSideByRND(int role_id, int rnd_num) {
    Integer lastSide = null;
    String key = "getUserWagerRcdSideByRND" + role_id + "|" + rnd_num;
    if ((lastSide = (Integer)FluctuantCache.getInstance().getCacheObject(key)) == null) {
      lastSide = Integer.valueOf(GameChiBiDAO.getUserWagerRcdSideByRND(role_id, rnd_num));
      FluctuantCache.getInstance().putCacheObject(key, lastSide);
    } 
    return lastSide.intValue();
  }
}
